# Set up your environment

Whether you want to contribute to Aspire, or just use the latest build of Aspire, these are the common pieces you need to install.

## (Windows) Install Visual Studio

On Windows, Visual Studio contains special tooling support for .NET Aspire that you will want to have.

[Visual Studio 2022 version 17.10 Preview](https://visualstudio.microsoft.com/vs/preview/)

When you install, ensure that both:
* `ASP.NET and web development` Workload is checked.
* `.NET Aspire SDK` component in `Individual components` is checked.

## Install the latest .NET 8 SDK
[.NET 8 SDK](https://github.com/dotnet/installer#installers-and-binaries)

## Install a supported container runtime

### Docker Desktop
* [Windows](https://docs.docker.com/desktop/install/windows-install/)
* [MacOS X](https://docs.docker.com/desktop/install/mac-install/)
* [Linux](https://docs.docker.com/desktop/install/linux-install/)

### Podman
* [Windows](https://podman.io/docs/installation#windows)
* [macOS](https://podman.io/docs/installation#macos)
* [Linux](https://podman.io/docs/installation#installing-on-linux)
